package com.hungraim.ltc.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hungraim.ltc.api.OrganFeignService;
import com.hungraim.ltc.dao.ChDisableApplyMapper;
import com.hungraim.ltc.dao.ReTaskMapper;
import com.hungraim.ltc.dao.TaskMapper;
import com.hungraim.ltc.pojo.entity.assessment.ChAprTask;
import com.hungraim.ltc.pojo.entity.disable.ChDisableApply;
import com.hungraim.ltc.pojo.vo.assessment.ChAprTaskVo;
import com.hungraim.ltc.pojo.vo.assessment.ReTaskDistributionVO;
import com.hungraim.ltc.pojo.vo.disable.ChDisableApplyVo;
import com.hungraim.ltc.service.ReTaskService;
import com.hungraim.ltc.util.DateUtils;
import com.hungraim.ltc.util.Result;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author czz
 */
@Service
@Slf4j
@AllArgsConstructor
public class ReTaskServiceImpl extends ServiceImpl<TaskMapper, ChAprTask> implements  ReTaskService {
    private final TaskMapper taskMapper;
    private final OrganFeignService organFeignService;
    private final ChDisableApplyMapper disableApplyMapper;
    private final ChDisableApplyMapper chDisableApplyMapper;
    private final ReTaskMapper reTaskMapper;
    @Override
    public Page<ReTaskDistributionVO> reTaskDistributionList(Page<ReTaskDistributionVO> page, Long organId, Boolean isIncluded, String acptProvincial, String acptCity, String acptCrea, String realName, String certiCode) {
        Result<List<Long>> organChild = null;
        List<Long> organIds = null;
        if (organId != null) {
            if (isIncluded == null) {
                isIncluded = false;
            }
            organChild = organFeignService.getOrganChild(organId, isIncluded);
            organIds = organChild.getData();
        }
        return taskMapper.reTaskDistributionList(page, organIds, acptProvincial, acptCity, acptCrea, realName, certiCode);
    }

    @Override
    public ChDisableApplyVo reassmentDetailById(String applyId) {
        ChDisableApplyVo chDisableApplyVo=null;
        chDisableApplyVo = chDisableApplyMapper.getReassmentDetailById(applyId);
        return chDisableApplyVo;
    }

    @Override
    public List<ChAprTaskVo> geReTaskHisInfoList(String disableInfoId) {
        // 历史评定信息列表
        List<ChAprTaskVo> reTaskHisInfoList = reTaskMapper.getReTaskHisInfoList(disableInfoId);
        return reTaskHisInfoList;
    }
}